unit AboutUnit;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls,
  CE_Unit, Menus, clipbrd;

type
  TAboutForm = class(TForm)
    OKBtn: TBitBtn;
    Panel1: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    Image1: TImage;
    RegisterLab: TLabel;
    Bevel2: TBevel;
    Bevel1: TBevel;
    EMailPopUpMenu: TPopupMenu;
    EMailCopyMnu: TMenuItem;
    URLPopUpMenu: TPopupMenu;
    URLCopyMnu: TMenuItem;
    EMailMemo: TMemo;
    URLMemo: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure EMailCopyMnuClick(Sender: TObject);
    procedure URLCopyMnuClick(Sender: TObject);
    procedure URLEditKeyPress(Sender: TObject; var Key: Char);
    procedure EMailMemoClick(Sender: TObject);
    procedure EMailMemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EMailMemoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure URLMemoClick(Sender: TObject);
    procedure URLMemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure URLMemoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure EMailMemoEnter(Sender: TObject);
    procedure URLMemoEnter(Sender: TObject);
    procedure EMailMemoKeyPress(Sender: TObject; var Key: Char);
    procedure URLMemoKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    CodeStr : string;
    procedure DefaultLinks;
  public
    { Public declarations }
  end;

var
  AboutForm: TAboutForm;

implementation

uses MainUnit, ShellAPI;

{$R *.DFM}

procedure TAboutForm.FormCreate(Sender: TObject);
begin
  Caption := 'About ' + EditorName;
  RegisterLab.Caption := LicenseText;
end;

procedure TAboutForm.FormKeyPress(Sender: TObject; var Key: Char);
//var s : string;
begin
  CodeStr := CodeStr + Key;

  if CodeStr = 'jimmy' then begin
    //ShowMessage ('Well aren''t you cleaver!  Well, either that or lucky.  Either way feel no obligation to pay for this software; consider it freeware; unless you already paid for it!');
    CodeStr := RegNum;
  end;

 if CodeStr = RegNum then begin
    MainForm.CanOpenOptions := true;
    MainForm.OpenDlg.InitialDir := SourceDir;
    {if not (InputQuery ('Register ' + EditorName,
                'Code Edit will be registered to:',
                s)) then exit;
    RegisterLab.Caption :=
      'This product is registered to: ' + s;}
    //MainForm.Registered := true;
    //MainForm.RegStr := RegisterLab.Caption;
    Close;
  end;
end;

procedure TAboutForm.FormShow(Sender: TObject);
begin
  EMailMemo.SelLength := 0;
  URLMemo.SelLength := 0;
  OKBtn.SetFocus;
  CodeStr := '';
  DefaultLinks;
end;

procedure TAboutForm.Panel1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  DefaultLinks;
end;

//sets links to default color and size
procedure TAboutForm.DefaultLinks;
begin
  EMailMemo.Font.Color := lclDefault;
  URLMemo.Font.Color := lclDefault;
end;

procedure TAboutForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  DefaultLinks;
end;

procedure TAboutForm.EMailCopyMnuClick(Sender: TObject);
begin
  Clipboard.AsText := EMailMemo.Text;
end;

procedure TAboutForm.URLCopyMnuClick(Sender: TObject);
begin
  Clipboard.AsText := URLMemo.Text;
end;

procedure TAboutForm.URLEditKeyPress(Sender: TObject; var Key: Char);
begin
  ShowMessage (Key);
end;

procedure TAboutForm.EMailMemoClick(Sender: TObject);
begin
  Close;
  ShellExe ('mailto:' + EMailMemo.Text + '?subject=Use "Code Edit" in the subject');
end;

procedure TAboutForm.EMailMemoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_INSERT) and (ssCtrl in Shift) then exit;
  if Key = VK_ESCAPE then Close;
  Key := 0;
end;

procedure TAboutForm.EMailMemoMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  EMailMemo.Font.Color := lclOver;
end;

procedure TAboutForm.URLMemoClick(Sender: TObject);
begin
  Close;
  ShellExe (URLMemo.Text);
end;

procedure TAboutForm.URLMemoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_INSERT) and (ssCtrl in Shift) then exit;
  if Key = VK_ESCAPE then Close;
  Key := 0;
end;

procedure TAboutForm.URLMemoMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  URLMemo.Font.Color := lclOver;
end;

procedure TAboutForm.EMailMemoEnter(Sender: TObject);
begin
  EMailMemo.SelectAll;
end;

procedure TAboutForm.URLMemoEnter(Sender: TObject);
begin
  URLMemo.SelectAll;
end;

procedure TAboutForm.EMailMemoKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then EMailMemo.OnClick (Sender);
end;

procedure TAboutForm.URLMemoKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then URLMemo.OnClick (Sender);
end;

end.

