unit EnvironmentUnit;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ColorGrd, StdCtrls, ExtCtrls, Buttons,
  ComCtrls, Spin, Grids,
  CE_Unit, ReuUnit, Menus;

type
  TEnvironmentForm = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    KeystrokeRG: TRadioGroup;
    StartWithRG: TRadioGroup;
    ColorRG: TRadioGroup;
    BackupExtRG: TRadioGroup;
    GroupBox3: TGroupBox;
    ColorGrid1: TColorGrid;
    GroupBox4: TGroupBox;
    AutosaveCB: TCheckBox;
    IntervalLab: TLabel;
    IntervalSE: TSpinEdit;
    HelpBtn: TBitBtn;
    GroupBox5: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    ShowHintsCB: TCheckBox;
    HintElapseEdit: TEdit;
    HintDurationEdit: TEdit;
    TabsGB: TGroupBox;
    XSpacesSE: TSpinEdit;
    XSpacesLab: TLabel;
    TabUseRG: TRadioGroup;
    GroupBox1: TGroupBox;
    PersistentGroupsCB: TCheckBox;
    ConfirmPromptCB: TCheckBox;
    AutoIndentCB: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
    procedure ColorGrid1Change(Sender: TObject);
    procedure AutosaveCBClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure IntervalSEKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TabUseRGClick(Sender: TObject);
  private
    { Private declarations }
    procedure ChangeAuto;
    procedure ChangeTabUse;
  public
    { Public declarations }
  end;

var
  EnvironmentForm: TEnvironmentForm;

implementation

uses MainUnit, OrderUnit;

{$R *.DFM}

procedure TEnvironmentForm.ChangeAuto;
begin
  IntervalSE.Enabled := AutoSaveCB.Checked;
  IntervalLab.Enabled := AutoSaveCB.Checked;
end;

procedure TEnvironmentForm.ChangeTabUse;
begin
  XSpacesLab.Enabled := TabUseRG.ItemIndex = TU_XSPACES;
  XSpacesSE.Enabled := TabUseRG.ItemIndex = TU_XSPACES;
end;

procedure TEnvironmentForm.OKBtnClick(Sender: TObject);
begin
  with MainForm do begin
    if KeystrokeRG.ItemIndex = 0 then
      ChangeKeyMap (kmWindows)
    else
      ChangeKeyMap (kmPascal);

    CustomBack := ColorGrid1.BackGroundColor;
    CustomFore := ColorGrid1.ForeGroundColor;
    AssignColorScheme (ColorRG.ItemIndex);

    Timer1.Interval := IntervalSE.Value * 60000;
    Timer1.Enabled := AutoSaveCB.Checked;

    StartWith := StartWithRG.ItemIndex;

    BackupExt := IntToBackupExt (BackupExtRG.ItemIndex);

    PersistentGroups := PersistentGroupsCB.Checked;
    ConfirmPrompt := ConfirmPromptCB.Checked;
    AutoIndent := AutoIndentCB.Checked;

    TabUse.Load (TabUseRG, XSpacesSE);
  end;//with MainForm
  
  with Application do begin
    ShowHint := ShowHintsCB.Checked;
    HintPause := Int (HintElapseEdit.Text );
    HintHidePause := Int (HintDurationEdit.Text);
  end;
end;

procedure TEnvironmentForm.ColorGrid1Change(Sender: TObject);
begin
  ColorRG.ItemIndex := 2; //Custom
end;

procedure TEnvironmentForm.AutoSaveCBClick(Sender: TObject);
begin
  ChangeAuto;
end;

procedure TEnvironmentForm.FormShow(Sender: TObject);
begin
  with MainForm do begin
    ColorGrid1.ForeGroundIndex := ColorToIndex (CustomFore);
    ColorGrid1.BackGroundIndex := ColorToIndex (CustomBack);

    ColorRG.ItemIndex := Ord (ColorScheme);

    KeystrokeRG.ItemIndex := Ord (KeyMap);
    AutoSaveCB.Checked := Timer1.Enabled;
    ChangeAuto;
    IntervalSE.Value := Round (Timer1.Interval div 60000);
    StartWithRG.ItemIndex := StartWith;

    BackupExtRG.ItemIndex := Ord (BackupExt);

    PersistentGroupsCB.Checked := PersistentGroups;
    ConfirmPromptCB.Checked := ConfirmPrompt;
    AutoIndentCB.Checked := AutoIndent;

    TabUse.Store (TabUseRG, XSpacesSE);
    ChangeTabUse;
  end;

  with Application do begin
    ShowHintsCB.Checked := ShowHint;
    HintElapseEdit.Text := IntToStr (HintPause);
    HintDurationEdit.Text := IntToStr (HintHidePause);
  end;
end;

procedure TEnvironmentForm.IntervalSEKeyPress(Sender: TObject;
  var Key: Char);
begin
  ValidateKey (Key);
end;

procedure TEnvironmentForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_F1 then HelpBtn.Click;
end;

procedure TEnvironmentForm.TabUseRGClick(Sender: TObject);
begin
  ChangeTabUse;
end;


end.

