unit FindUnit;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls,
  CE_Unit;

type
  TFindForm = class(TForm)
    Bevel1: TBevel;
    Label1: TLabel;
    FindEdit: TEdit;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    GroupBox1: TGroupBox;
    FromCursorCB: TCheckBox;
    MatchCaseCB: TCheckBox;
    SelectedCB: TCheckBox;
    WholeWordCB: TCheckBox;
    procedure Label1Click(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    function GetOptions : TSearchTypes;
  public
    { Public declarations }
    Options : TSearchTypes;
  end;

var
  FindForm: TFindForm;

implementation

uses MainUnit;

{$R *.DFM}

procedure TFindForm.Label1Click(Sender: TObject);
begin
  FindEdit.SetFocus;
end;

procedure TFindForm.OKBtnClick(Sender: TObject);
begin
  Hide;
  with MainForm do begin
    FindText := FindEdit.Text;

    with Edit do
      if SelectedCB.Checked then begin
        FindPosition := SelStart;
        EndFindPosition := SelStart + SelLength - 1;
      end else if FromCursorCB.Checked then begin
        //if DownCB.Checked then begin
          FindPosition := SelStart;
          EndFindPosition := GetTextLen - 1;
        //end else begin
        //  FindPosition := 1;
        //  EndFindPosition := SelStart + 1;
        //end;
      end else begin
        FindPosition := 0;
        EndFindPosition := GetTextLen - 1;
      end;

    Options := GetOptions;
    if not Search (Options) then
      ShowFoundDlg (false);
  end;//with MainForm...
end;

procedure TFindForm.FormShow(Sender: TObject);
begin
  FindEdit.SetFocus;
  FindEdit.SelectAll;
  SelectedCB.Checked := MainForm.Edit.SelLength > 0;
end;

function TFindForm.GetOptions : TSearchTypes;
begin
  result := [];
  //if DownCB.Checked then result := result + [frDown];
  if MatchCaseCB.Checked then result := result + [stMatchCase];
  if WholeWordCB.Checked then result := result + [stWholeWord];
end;


end.

